#ifndef KP_ENTRY_PROPERTIES_DIALOG_H_
#define KP_ENTRY_PROPERTIES_DIALOG_H_

#include <gtk/gtk.h>
#include "kpcalendarview.h"
#include "../kptraininglog.h"
#include "../kputil.h"
#include "../kpresults.h"

#define KP_TYPE_ENTRY_PROPERTIES_DIALOG         (kp_entry_properties_dialog_get_type ())
#define KP_ENTRY_PROPERTIES_DIALOG(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), KP_TYPE_ENTRY_PROPERTIES_DIALOG, KPEntryPropertiesDialog))
#define KP_ENTRY_PROPERTIES_DIALOG_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), KP_TYPE_ENTRY_PROPERTIES_DIALOG, KPEntryPropertiesDialogClass))
#define KP_IS_ENTRY_PROPERTIES_DIALOG(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), KP_TYPE_ENTRY_PROPERTIES_DIALOG))
#define KP_IS_ENTRY_PROPERTIES_DIALOG_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), KP_TYPE_ENTRY_PROPERTIES_DIALOG))
#define KP_ENTRY_PROPERTIES_DIALOG_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), KP_TYPE_ENTRY_PROPERTIES_DIALOG, KPEntryPropertiesDialogClass))

typedef struct
{
  GtkDialog       parent;

  GtkWidget      *vbox;
  
  gpointer        private_data;
} KPEntryPropertiesDialog;

typedef struct
{
  GtkDialogClass  parent_class;
} KPEntryPropertiesDialogClass;

GType             kp_entry_properties_dialog_get_type    (void);

GtkWidget        *kp_entry_properties_dialog_new         (KPCalendarEntry *results);

void              kp_entry_properties_dialog_add_pair    (KPEntryPropertiesDialog *dialog,
                                                          const gchar *name,
                                                          GtkWidget *value, 
                                                          gboolean expand);
void              kp_entry_properties_dialog_add_triplet (KPEntryPropertiesDialog *dialog,
                                                          const gchar *name,
                                                          GtkWidget *value,
                                                          GtkWidget *value2,
                                                          gboolean expand);

#endif /* __KP_ENTRY_PROPERTIES_DIALOG_H */
